// CodeGear C++Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Se_pngimage.pas' rev: 11.00

#ifndef Se_pngimageHPP
#define Se_pngimageHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Se_zlib.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Se_pngimage
{
//-- type declarations -------------------------------------------------------
typedef tagRGBTRIPLE TRGBLine[65536];

typedef TRGBLine *pRGBLine;

#pragma pack(push,1)
struct TMAXBITMAPINFO
{
	
public:
	#pragma pack(push,1)
	tagBITMAPINFOHEADER bmiHeader;
	#pragma pack(pop)
	tagRGBQUAD bmiColors[256];
} ;
#pragma pack(pop)

#pragma option push -b-
enum TsePngTransparencyMode { bsptmNone, bsptmBit, bsptmPngLayerial };
#pragma option pop

typedef unsigned *pCardinal;

struct TRGBPixel;
typedef TRGBPixel *pRGBPixel;

#pragma pack(push,1)
struct TRGBPixel
{
	
public:
	Byte B;
	Byte G;
	Byte R;
} ;
#pragma pack(pop)

typedef Byte TByteArray[65536];

typedef TByteArray *PByteArray;

typedef void *TPointerArray[65536];

typedef TPointerArray *PPointerArray;

class DELPHICLASS TsePngPointerList;
class DELPHICLASS TsePngImage;
#pragma option push -b-
enum TseInterlaceMethod { bsimNone, bsimAdam7 };
#pragma option pop

class DELPHICLASS TsePngList;
class PASCALIMPLEMENTATION TsePngPointerList : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TsePngImage* fOwner;
	unsigned fCount;
	TPointerArray *fMemory;
	void * __fastcall GetItem(unsigned Index);
	void __fastcall SetItem(unsigned Index, const void * Value);
	
protected:
	virtual void * __fastcall Remove(void * Value);
	void __fastcall Insert(void * Value, unsigned Position);
	void __fastcall Add(void * Value);
	__property void * Item[unsigned Index] = {read=GetItem, write=SetItem};
	void __fastcall SetSize(const unsigned Size);
	__property TsePngImage* Owner = {read=fOwner};
	
public:
	__fastcall TsePngPointerList(TsePngImage* AOwner);
	__fastcall virtual ~TsePngPointerList(void);
	__property unsigned Count = {read=fCount, write=SetSize, nodefault};
};


class DELPHICLASS TsePngLayer;
typedef TMetaClass* TsePngLayerClass;

class PASCALIMPLEMENTATION TsePngList : public TsePngPointerList 
{
	typedef TsePngPointerList inherited;
	
private:
	HIDESBASE TsePngLayer* __fastcall GetItem(unsigned Index);
	
public:
	TsePngLayer* __fastcall FindPngLayer(TMetaClass* PngLayerClass);
	void __fastcall RemovePngLayer(TsePngLayer* PngLayer)/* overload */;
	HIDESBASE TsePngLayer* __fastcall Add(TMetaClass* PngLayerClass);
	TsePngLayer* __fastcall ItemFromClass(TMetaClass* PngLayerClass);
	__property TsePngLayer* Item[unsigned Index] = {read=GetItem};
public:
	#pragma option push -w-inl
	/* TsePngPointerList.Create */ inline __fastcall TsePngList(TsePngImage* AOwner) : TsePngPointerList(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TsePngPointerList.Destroy */ inline __fastcall virtual ~TsePngList(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TsePngFilter { bspfNone, bspfSub, bspfUp, bspfAverage, bspfPaeth };
#pragma option pop

typedef Set<TsePngFilter, bspfNone, bspfPaeth>  TsePngFilters;

typedef Shortint TseCompressionLevel;

class DELPHICLASS TsePngLayerIHDR;
class PASCALIMPLEMENTATION TsePngImage : public Graphics::TGraphic 
{
	typedef Graphics::TGraphic inherited;
	
private:
	int fMaxIdatSize;
	TseInterlaceMethod fInterlaceMethod;
	TsePngList* fPngLayerList;
	Graphics::TCanvas* fCanvas;
	TsePngFilters fFilters;
	TseCompressionLevel fCompressionLevel;
	void __fastcall ClearPngLayers(void);
	bool __fastcall HeaderPresent(void);
	void __fastcall GetPixelInfo(unsigned &LineSize, unsigned &Offset);
	void __fastcall SetMaxIdatSize(const int Value);
	PByteArray __fastcall GetAlphaScanline(const int LineIndex);
	void * __fastcall GetScanline(const int LineIndex);
	void * __fastcall GetExtraScanline(const int LineIndex);
	TsePngTransparencyMode __fastcall GetTransparencyMode(void);
	Graphics::TColor __fastcall GetTransparentColor(void);
	void __fastcall SetTransparentColor(const Graphics::TColor Value);
	
protected:
	Byte InverseGamma[256];
	bool BeingCreated;
	void __fastcall InitializeGamma(void);
	virtual HPALETTE __fastcall GetPalette(void);
	virtual void __fastcall SetPalette(HPALETTE Value);
	void __fastcall DoSetPalette(HPALETTE Value, const bool UpdateColors);
	virtual int __fastcall GetWidth(void);
	virtual int __fastcall GetHeight(void);
	virtual void __fastcall SetWidth(int Value);
	virtual void __fastcall SetHeight(int Value);
	void __fastcall AssignPNG(TsePngImage* Source);
	virtual bool __fastcall GetEmpty(void);
	TsePngLayerIHDR* __fastcall GetHeader(void);
	void __fastcall DrawPngLayerialTrans(HDC DC, const Types::TRect &Rect);
	virtual bool __fastcall GetTransparent(void);
	virtual Graphics::TColor __fastcall GetPixels(const int X, const int Y);
	virtual void __fastcall SetPixels(const int X, const int Y, const Graphics::TColor Value);
	
public:
	Byte GammaTable[256];
	void __fastcall Resize(const int CX, const int CY);
	void __fastcall CreateAlpha(void);
	void __fastcall RemoveTransparency(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall AssignTo(Classes::TPersistent* Dest);
	void __fastcall AssignHandle(HBITMAP Handle, bool Transparent, unsigned TransparentColor);
	virtual void __fastcall Draw(Graphics::TCanvas* ACanvas, const Types::TRect &Rect);
	__fastcall virtual TsePngImage(void);
	__fastcall TsePngImage(unsigned ColorType, unsigned Bitdepth, int cx, int cy);
	__fastcall virtual ~TsePngImage(void);
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream);
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	void __fastcall LoadFromResourceName(unsigned Instance, const AnsiString Name);
	void __fastcall LoadFromResourceID(unsigned Instance, int ResID);
	__property Graphics::TColor TransparentColor = {read=GetTransparentColor, write=SetTransparentColor, nodefault};
	__property void * Scanline[int Index] = {read=GetScanline};
	__property void * ExtraScanline[int Index] = {read=GetExtraScanline};
	__property PByteArray AlphaScanline[int Index] = {read=GetAlphaScanline};
	__property Graphics::TCanvas* Canvas = {read=fCanvas};
	__property TsePngLayerIHDR* Header = {read=GetHeader};
	__property TsePngTransparencyMode TransparencyMode = {read=GetTransparencyMode, nodefault};
	__property int Width = {read=GetWidth, nodefault};
	__property int Height = {read=GetHeight, nodefault};
	__property TseInterlaceMethod InterlaceMethod = {read=fInterlaceMethod, write=fInterlaceMethod, nodefault};
	__property TsePngFilters Filters = {read=fFilters, write=fFilters, nodefault};
	__property int MaxIdatSize = {read=fMaxIdatSize, write=SetMaxIdatSize, nodefault};
	__property bool Empty = {read=GetEmpty, nodefault};
	__property TseCompressionLevel CompressionLevel = {read=fCompressionLevel, write=fCompressionLevel, nodefault};
	__property TsePngList* PngLayers = {read=fPngLayerList};
	__property Graphics::TColor Pixels[int X][int Y] = {read=GetPixels, write=SetPixels};
};



typedef char TsePngLayerName[4];

class PASCALIMPLEMENTATION TsePngLayer : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	void *fData;
	unsigned fDataSize;
	TsePngImage* fOwner;
	char fName[4];
	TsePngLayerIHDR* __fastcall GetHeader(void);
	int __fastcall GetIndex(void);
	/* virtual class method */ virtual AnsiString __fastcall GetName(TMetaClass* vmt);
	AnsiString __fastcall GetPngLayerName();
	
public:
	void __fastcall ResizeData(const unsigned NewSize);
	virtual void __fastcall Assign(TsePngLayer* Source);
	__fastcall virtual TsePngLayer(TsePngImage* Owner);
	__fastcall virtual ~TsePngLayer(void);
	virtual bool __fastcall LoadFromStream(Classes::TStream* Stream, char const * PngLayerName, int Size);
	bool __fastcall SaveData(Classes::TStream* Stream);
	virtual bool __fastcall SaveToStream(Classes::TStream* Stream);
	__property int Index = {read=GetIndex, nodefault};
	__property TsePngLayerIHDR* Header = {read=GetHeader};
	__property void * Data = {read=fData};
	__property unsigned DataSize = {read=fDataSize, nodefault};
	__property TsePngImage* Owner = {read=fOwner};
	__property AnsiString Name = {read=GetPngLayerName};
};


class DELPHICLASS TsePngLayerIEND;
class PASCALIMPLEMENTATION TsePngLayerIEND : public TsePngLayer 
{
	typedef TsePngLayer inherited;
	
public:
	#pragma option push -w-inl
	/* TsePngLayer.Create */ inline __fastcall virtual TsePngLayerIEND(TsePngImage* Owner) : TsePngLayer(Owner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TsePngLayer.Destroy */ inline __fastcall virtual ~TsePngLayerIEND(void) { }
	#pragma option pop
	
};


struct TIHDRData;
typedef TIHDRData *pIHDRData;

#pragma pack(push,1)
struct TIHDRData
{
	
public:
	unsigned Width;
	unsigned Height;
	Byte BitDepth;
	Byte ColorType;
	Byte CompressionMethod;
	Byte FilterMethod;
	Byte InterlaceMethod;
} ;
#pragma pack(pop)

class PASCALIMPLEMENTATION TsePngLayerIHDR : public TsePngLayer 
{
	typedef TsePngLayer inherited;
	
private:
	HBITMAP ImageHandle;
	HDC ImageDC;
	HPALETTE ImagePalette;
	bool HasPalette;
	#pragma pack(push,1)
	TMAXBITMAPINFO BitmapInfo;
	#pragma pack(pop)
	void *ExtraImageData;
	void *ImageData;
	void *ImageAlpha;
	#pragma pack(push,1)
	TIHDRData IHDRData;
	#pragma pack(pop)
	
protected:
	int BytesPerRow;
	HPALETTE __fastcall CreateGrayscalePalette(int Bitdepth);
	void __fastcall PaletteToDIB(HPALETTE Palette);
	void __fastcall PrepareImageData(void);
	void __fastcall FreeImageData(void);
	
public:
	virtual bool __fastcall LoadFromStream(Classes::TStream* Stream, char const * PngLayerName, int Size);
	virtual bool __fastcall SaveToStream(Classes::TStream* Stream);
	__fastcall virtual TsePngLayerIHDR(TsePngImage* Owner);
	__fastcall virtual ~TsePngLayerIHDR(void);
	virtual void __fastcall Assign(TsePngLayer* Source);
	__property HBITMAP ImageHandleValue = {read=ImageHandle, nodefault};
	__property unsigned Width = {read=IHDRData.Width, write=IHDRData.Width, nodefault};
	__property unsigned Height = {read=IHDRData.Height, write=IHDRData.Height, nodefault};
	__property Byte BitDepth = {read=IHDRData.BitDepth, write=IHDRData.BitDepth, nodefault};
	__property Byte ColorType = {read=IHDRData.ColorType, write=IHDRData.ColorType, nodefault};
	__property Byte CompressionMethod = {read=IHDRData.CompressionMethod, write=IHDRData.CompressionMethod, nodefault};
	__property Byte FilterMethod = {read=IHDRData.FilterMethod, write=IHDRData.FilterMethod, nodefault};
	__property Byte InterlaceMethod = {read=IHDRData.InterlaceMethod, write=IHDRData.InterlaceMethod, nodefault};
};


#pragma option push -b-
enum TUnitType { utUnknown, utMeter };
#pragma option pop

typedef TUnitType *pUnitType;

class DELPHICLASS TsePngLayerpHYs;
class PASCALIMPLEMENTATION TsePngLayerpHYs : public TsePngLayer 
{
	typedef TsePngLayer inherited;
	
private:
	unsigned fPPUnitX;
	unsigned fPPUnitY;
	TUnitType fUnit;
	
public:
	virtual bool __fastcall LoadFromStream(Classes::TStream* Stream, char const * PngLayerName, int Size);
	virtual bool __fastcall SaveToStream(Classes::TStream* Stream);
	virtual void __fastcall Assign(TsePngLayer* Source);
	__property unsigned PPUnitX = {read=fPPUnitX, write=fPPUnitX, nodefault};
	__property unsigned PPUnitY = {read=fPPUnitY, write=fPPUnitY, nodefault};
	__property TUnitType UnitType = {read=fUnit, write=fUnit, nodefault};
public:
	#pragma option push -w-inl
	/* TsePngLayer.Create */ inline __fastcall virtual TsePngLayerpHYs(TsePngImage* Owner) : TsePngLayer(Owner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TsePngLayer.Destroy */ inline __fastcall virtual ~TsePngLayerpHYs(void) { }
	#pragma option pop
	
};


class DELPHICLASS TsePngLayergAMA;
class PASCALIMPLEMENTATION TsePngLayergAMA : public TsePngLayer 
{
	typedef TsePngLayer inherited;
	
private:
	unsigned __fastcall GetValue(void);
	void __fastcall SetValue(const unsigned Value);
	
public:
	virtual bool __fastcall LoadFromStream(Classes::TStream* Stream, char const * PngLayerName, int Size);
	__fastcall virtual TsePngLayergAMA(TsePngImage* Owner);
	virtual void __fastcall Assign(TsePngLayer* Source);
	__property unsigned Gamma = {read=GetValue, write=SetValue, nodefault};
public:
	#pragma option push -w-inl
	/* TsePngLayer.Destroy */ inline __fastcall virtual ~TsePngLayergAMA(void) { }
	#pragma option pop
	
};


#pragma pack(push,1)
struct TZStreamRec2
{
	
public:
	Se_zlib::z_stream ZLIB;
	void *Data;
	Classes::TStream* fStream;
} ;
#pragma pack(pop)

class DELPHICLASS TsePngLayerPLTE;
class PASCALIMPLEMENTATION TsePngLayerPLTE : public TsePngLayer 
{
	typedef TsePngLayer inherited;
	
protected:
	int fCount;
	
private:
	tagRGBQUAD __fastcall GetPaletteItem(Byte Index);
	
public:
	__property tagRGBQUAD Item[Byte Index] = {read=GetPaletteItem};
	__property int Count = {read=fCount, nodefault};
	virtual bool __fastcall LoadFromStream(Classes::TStream* Stream, char const * PngLayerName, int Size);
	virtual bool __fastcall SaveToStream(Classes::TStream* Stream);
	virtual void __fastcall Assign(TsePngLayer* Source);
public:
	#pragma option push -w-inl
	/* TsePngLayer.Create */ inline __fastcall virtual TsePngLayerPLTE(TsePngImage* Owner) : TsePngLayer(Owner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TsePngLayer.Destroy */ inline __fastcall virtual ~TsePngLayerPLTE(void) { }
	#pragma option pop
	
};


class DELPHICLASS TsePngLayertRNS;
class PASCALIMPLEMENTATION TsePngLayertRNS : public TsePngLayer 
{
	typedef TsePngLayer inherited;
	
private:
	bool fBitTransparency;
	unsigned __fastcall GetTransparentColor(void);
	void __fastcall SetTransparentColor(const unsigned Value);
	
public:
	Byte PaletteValues[256];
	virtual bool __fastcall LoadFromStream(Classes::TStream* Stream, char const * PngLayerName, int Size);
	virtual bool __fastcall SaveToStream(Classes::TStream* Stream);
	virtual void __fastcall Assign(TsePngLayer* Source);
	__property bool BitTransparency = {read=fBitTransparency, nodefault};
	__property unsigned TransparentColor = {read=GetTransparentColor, write=SetTransparentColor, nodefault};
public:
	#pragma option push -w-inl
	/* TsePngLayer.Create */ inline __fastcall virtual TsePngLayertRNS(TsePngImage* Owner) : TsePngLayer(Owner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TsePngLayer.Destroy */ inline __fastcall virtual ~TsePngLayertRNS(void) { }
	#pragma option pop
	
};


class DELPHICLASS TsePngLayerIDAT;
class PASCALIMPLEMENTATION TsePngLayerIDAT : public TsePngLayer 
{
	typedef TsePngLayer inherited;
	
private:
	TsePngLayerIHDR* Header;
	int ImageWidth;
	int ImageHeight;
	unsigned Row_Bytes;
	unsigned Offset;
	TByteArray *Encode_Buffer[6];
	TByteArray *Row_Buffer[2];
	bool RowUsed;
	int EndPos;
	void __fastcall FilterRow(void);
	Byte __fastcall FilterToEncode(void);
	int __fastcall IDATZlibRead(TZStreamRec2 &ZLIBStream, void * Buffer, int Count, int &EndPos, unsigned &crcfile);
	void __fastcall IDATZlibWrite(TZStreamRec2 &ZLIBStream, void * Buffer, const unsigned Length);
	void __fastcall FinishIDATZlib(TZStreamRec2 &ZLIBStream);
	void __fastcall PreparePalette(void);
	
protected:
	void __fastcall DecodeInterlacedAdam7(Classes::TStream* Stream, TZStreamRec2 &ZLIBStream, const int Size, unsigned &crcfile);
	void __fastcall DecodeNonInterlaced(Classes::TStream* Stream, TZStreamRec2 &ZLIBStream, const int Size, unsigned &crcfile);
	void __fastcall EncodeNonInterlaced(Classes::TStream* Stream, TZStreamRec2 &ZLIBStream);
	void __fastcall EncodeInterlacedAdam7(Classes::TStream* Stream, TZStreamRec2 &ZLIBStream);
	void __fastcall CopyNonInterlacedRGB8(char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyNonInterlacedRGB16(char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyNonInterlacedPalette148(char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyNonInterlacedPalette2(char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyNonInterlacedGray2(char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyNonInterlacedGrayscale16(char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyNonInterlacedRGBAlpha8(char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyNonInterlacedRGBAlpha16(char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyNonInterlacedGrayscaleAlpha8(char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyNonInterlacedGrayscaleAlpha16(char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyInterlacedRGB8(const Byte Pass, char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyInterlacedRGB16(const Byte Pass, char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyInterlacedPalette148(const Byte Pass, char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyInterlacedPalette2(const Byte Pass, char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyInterlacedGray2(const Byte Pass, char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyInterlacedGrayscale16(const Byte Pass, char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyInterlacedRGBAlpha8(const Byte Pass, char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyInterlacedRGBAlpha16(const Byte Pass, char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyInterlacedGrayscaleAlpha8(const Byte Pass, char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall CopyInterlacedGrayscaleAlpha16(const Byte Pass, char * Src, char * Dest, char * Trans, char * Extra);
	void __fastcall EncodeNonInterlacedRGB8(char * Src, char * Dest, char * Trans);
	void __fastcall EncodeNonInterlacedRGB16(char * Src, char * Dest, char * Trans);
	void __fastcall EncodeNonInterlacedGrayscale16(char * Src, char * Dest, char * Trans);
	void __fastcall EncodeNonInterlacedPalette148(char * Src, char * Dest, char * Trans);
	void __fastcall EncodeNonInterlacedRGBAlpha8(char * Src, char * Dest, char * Trans);
	void __fastcall EncodeNonInterlacedRGBAlpha16(char * Src, char * Dest, char * Trans);
	void __fastcall EncodeNonInterlacedGrayscaleAlpha8(char * Src, char * Dest, char * Trans);
	void __fastcall EncodeNonInterlacedGrayscaleAlpha16(char * Src, char * Dest, char * Trans);
	void __fastcall EncodeInterlacedRGB8(const Byte Pass, char * Src, char * Dest, char * Trans);
	void __fastcall EncodeInterlacedRGB16(const Byte Pass, char * Src, char * Dest, char * Trans);
	void __fastcall EncodeInterlacedPalette148(const Byte Pass, char * Src, char * Dest, char * Trans);
	void __fastcall EncodeInterlacedGrayscale16(const Byte Pass, char * Src, char * Dest, char * Trans);
	void __fastcall EncodeInterlacedRGBAlpha8(const Byte Pass, char * Src, char * Dest, char * Trans);
	void __fastcall EncodeInterlacedRGBAlpha16(const Byte Pass, char * Src, char * Dest, char * Trans);
	void __fastcall EncodeInterlacedGrayscaleAlpha8(const Byte Pass, char * Src, char * Dest, char * Trans);
	void __fastcall EncodeInterlacedGrayscaleAlpha16(const Byte Pass, char * Src, char * Dest, char * Trans);
	
public:
	virtual bool __fastcall LoadFromStream(Classes::TStream* Stream, char const * PngLayerName, int Size);
	virtual bool __fastcall SaveToStream(Classes::TStream* Stream);
public:
	#pragma option push -w-inl
	/* TsePngLayer.Create */ inline __fastcall virtual TsePngLayerIDAT(TsePngImage* Owner) : TsePngLayer(Owner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TsePngLayer.Destroy */ inline __fastcall virtual ~TsePngLayerIDAT(void) { }
	#pragma option pop
	
};


class DELPHICLASS TsePngLayertIME;
class PASCALIMPLEMENTATION TsePngLayertIME : public TsePngLayer 
{
	typedef TsePngLayer inherited;
	
private:
	Word fYear;
	Byte fMonth;
	Byte fDay;
	Byte fHour;
	Byte fMinute;
	Byte fSecond;
	
public:
	virtual bool __fastcall LoadFromStream(Classes::TStream* Stream, char const * PngLayerName, int Size);
	virtual bool __fastcall SaveToStream(Classes::TStream* Stream);
	virtual void __fastcall Assign(TsePngLayer* Source);
	__property Word Year = {read=fYear, write=fYear, nodefault};
	__property Byte Month = {read=fMonth, write=fMonth, nodefault};
	__property Byte Day = {read=fDay, write=fDay, nodefault};
	__property Byte Hour = {read=fHour, write=fHour, nodefault};
	__property Byte Minute = {read=fMinute, write=fMinute, nodefault};
	__property Byte Second = {read=fSecond, write=fSecond, nodefault};
public:
	#pragma option push -w-inl
	/* TsePngLayer.Create */ inline __fastcall virtual TsePngLayertIME(TsePngImage* Owner) : TsePngLayer(Owner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TsePngLayer.Destroy */ inline __fastcall virtual ~TsePngLayertIME(void) { }
	#pragma option pop
	
};


class DELPHICLASS TsePngLayertEXt;
class PASCALIMPLEMENTATION TsePngLayertEXt : public TsePngLayer 
{
	typedef TsePngLayer inherited;
	
private:
	AnsiString fKeyword;
	AnsiString fText;
	
public:
	virtual bool __fastcall LoadFromStream(Classes::TStream* Stream, char const * PngLayerName, int Size);
	virtual bool __fastcall SaveToStream(Classes::TStream* Stream);
	virtual void __fastcall Assign(TsePngLayer* Source);
	__property AnsiString Keyword = {read=fKeyword, write=fKeyword};
	__property AnsiString Text = {read=fText, write=fText};
public:
	#pragma option push -w-inl
	/* TsePngLayer.Create */ inline __fastcall virtual TsePngLayertEXt(TsePngImage* Owner) : TsePngLayer(Owner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TsePngLayer.Destroy */ inline __fastcall virtual ~TsePngLayertEXt(void) { }
	#pragma option pop
	
};


class DELPHICLASS TsePngLayerzTXt;
class PASCALIMPLEMENTATION TsePngLayerzTXt : public TsePngLayertEXt 
{
	typedef TsePngLayertEXt inherited;
	
public:
	virtual bool __fastcall LoadFromStream(Classes::TStream* Stream, char const * PngLayerName, int Size);
	virtual bool __fastcall SaveToStream(Classes::TStream* Stream);
public:
	#pragma option push -w-inl
	/* TsePngLayer.Create */ inline __fastcall virtual TsePngLayerzTXt(TsePngImage* Owner) : TsePngLayertEXt(Owner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TsePngLayer.Destroy */ inline __fastcall virtual ~TsePngLayerzTXt(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint Z_NO_FLUSH = 0x0;
static const Shortint Z_FINISH = 0x4;
static const Shortint Z_STREAM_END = 0x1;
static const Shortint FILTER_NONE = 0x0;
static const Shortint FILTER_SUB = 0x1;
static const Shortint FILTER_UP = 0x2;
static const Shortint FILTER_AVERAGE = 0x3;
static const Shortint FILTER_PAETH = 0x4;
static const Shortint COLOR_GRAYSCALE = 0x0;
static const Shortint COLOR_RGB = 0x2;
static const Shortint COLOR_PALETTE = 0x3;
static const Shortint COLOR_GRAYSCALEALPHA = 0x4;
static const Shortint COLOR_RGBALPHA = 0x6;
extern PACKAGE unsigned __fastcall update_crc(int crc, PByteArray buf, int len);
extern PACKAGE int __fastcall ByteSwap(const int a);
extern PACKAGE void __fastcall RegisterPngLayer(TMetaClass* PngLayerClass);

}	/* namespace Se_pngimage */
using namespace Se_pngimage;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Se_pngimage
