// CodeGear C++Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Se_effect.pas' rev: 11.00

#ifndef Se_effectHPP
#define Se_effectHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Clipbrd.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Extctrls.hpp>	// Pascal unit
#include <Imglist.hpp>	// Pascal unit
#include <Se_bitmap.hpp>	// Pascal unit
#include <Se_utils.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Se_effect
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (*TseProc)(void);

typedef Byte TseMatrixFade[1];

typedef TseMatrixFade *PseMatrixFade;

typedef void __fastcall (*TseProcFade)(Byte * Matrix, int Width, int Height, Byte Percent);

struct TsePointSlide
{
	
public:
	Byte Alpha;
	short X;
	short Y;
} ;

typedef TsePointSlide TseMatrixSlide[1];

typedef TseMatrixSlide *PseMatrixSlide;

typedef void __fastcall (*TseProcSlide)(TsePointSlide * Matrix, int Width, int Height, Byte Percent);

class DELPHICLASS TseAnimationRec;
typedef void __fastcall (*TseProcManual)(Se_bitmap::TseBitmap* SourceImage, Se_bitmap::TseBitmap* DestImage, TseAnimationRec* Animation, Byte Percent);

#pragma option push -b-
enum TseProcKind { pkFade, pkSlide, pkManual };
#pragma option pop

class DELPHICLASS TseProcItem;
class PASCALIMPLEMENTATION TseProcItem : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TseProcKind FKind;
	TseProc FProc;
	AnsiString FName;
	
public:
	__property TseProcKind Kind = {read=FKind, write=FKind, nodefault};
	__property TseProc Proc = {read=FProc, write=FProc};
	__property AnsiString Name = {read=FName, write=FName};
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TseProcItem(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TseProcItem(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TseRotation { krNone, krRotate90, krRotate180, krRotate270 };
#pragma option pop

typedef AnsiString TseEffectKind;

class PASCALIMPLEMENTATION TseAnimationRec : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FEnabled;
	int FTime;
	int FResolution;
	int FTileCount;
	AnsiString FEffect;
	TseRotation FRotation;
	Graphics::TBitmap* FBitmap;
	void __fastcall SetResolution(const int Value);
	void __fastcall SetTileCount(const int Value);
	void __fastcall SetTime(const int Value);
	void __fastcall SetBitmap(const Graphics::TBitmap* Value);
	
public:
	__fastcall virtual TseAnimationRec(Classes::TComponent* AOwner);
	__fastcall virtual ~TseAnimationRec(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Graphics::TBitmap* Bitmap = {read=FBitmap, write=SetBitmap};
	__property AnsiString Effect = {read=FEffect, write=FEffect};
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=0};
	__property int Resolution = {read=FResolution, write=SetResolution, default=1};
	__property TseRotation Rotation = {read=FRotation, write=FRotation, default=0};
	__property int TileCount = {read=FTileCount, write=SetTileCount, default=1};
	__property int Time = {read=FTime, write=SetTime, default=400};
};


class DELPHICLASS TseProcList;
class PASCALIMPLEMENTATION TseProcList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	TseProcItem* operator[](AnsiString Index) { return Procs[Index]; }
	
private:
	TseProcItem* __fastcall GetProcs(AnsiString Index);
	
public:
	virtual void __fastcall Clear(void);
	__property TseProcItem* Procs[AnsiString Index] = {read=GetProcs/*, default*/};
public:
	#pragma option push -w-inl
	/* TList.Destroy */ inline __fastcall virtual ~TseProcList(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TseProcList(void) : Classes::TList() { }
	#pragma option pop
	
};


class DELPHICLASS EProcItemError;
class PASCALIMPLEMENTATION EProcItemError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EProcItemError(const AnsiString Msg) : Sysutils::Exception(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EProcItemError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EProcItemError(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EProcItemError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EProcItemError(const AnsiString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EProcItemError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EProcItemError(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EProcItemError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EProcItemError(void) { }
	#pragma option pop
	
};


class DELPHICLASS TseTimer;
class PASCALIMPLEMENTATION TseTimer : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	__int64 StartValue;
	__int64 StopValue;
	__int64 FFrequency;
	__int64 FCalibrate;
	Extended __fastcall GetElapsed(void);
	void __fastcall CalibrateWindows(void);
	
protected:
	__property __int64 Calibrate = {read=FCalibrate};
	
public:
	__fastcall TseTimer(void);
	__int64 __fastcall GetFrequency(void);
	void __fastcall Start(void);
	void __fastcall Stop(void);
	__property Extended Elapsed = {read=GetElapsed};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TseTimer(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::ResourceString _SProcListAlreadyExists;
#define Se_effect_SProcListAlreadyExists System::LoadResourceString(&Se_effect::_SProcListAlreadyExists)
#define SRandomSelection "[ RANDOM ] - Random selection"
#define SBitmap "[ BITMAP ] - Bitmap Animation"
#define SFade "[ FADE ] - "
#define SSlide "[ SLIDE ] - "
#define SManual "[ MANUAL ] - "
static const unsigned AlphaMask = 0xff000000;
extern PACKAGE TseProcList* ProcList;
extern PACKAGE Classes::TStrings* EffectList;
extern PACKAGE int __fastcall ReserveIndex(void);
extern PACKAGE void __fastcall ReleaseReserved(int AIndex);
extern PACKAGE int __fastcall StartMultiAnimation(Graphics::TCanvas* ACanvas, int AX, int AY, Se_bitmap::TseBitmap* ASourceImage, Se_bitmap::TseBitmap* ADestImage, TseAnimationRec* AAnimation, int AIndex = 0xffffffff);
extern PACKAGE void __fastcall StopMultiAnimation(int AIndex, bool DrawLastFrame = false);
extern PACKAGE bool __fastcall IsAnimating(int AIndex);
extern PACKAGE void __fastcall ExecuteAnimation(Graphics::TCanvas* ACanvas, int AX, int AY, Se_bitmap::TseBitmap* ASourceImage, Se_bitmap::TseBitmap* ADestImage, TseAnimationRec* AAnimation);
extern PACKAGE void __fastcall StretchAlphaRect(void *X, int Width, int Height, int XDst, int YDst, int WDst, int HDst, int XSrc, int YSrc, int WSrc, int HSrc, void *Alpha);
extern PACKAGE void __fastcall RegisterProc(AnsiString AName, TseProcKind AKind, TseProc AProc);
extern PACKAGE AnsiString __fastcall GetEffectListComma();
extern PACKAGE Classes::TStrings* __fastcall GetEffectList(void)/* overload */;
extern PACKAGE void __fastcall StartTimer(TseTimer* &Timer);
extern PACKAGE float __fastcall StopTimer(TseTimer* &Timer);

}	/* namespace Se_effect */
using namespace Se_effect;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Se_effect
