// CodeGear C++Builder
// Copyright (c) 1995, 2009 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Se_bitmap.pas' rev: 21.00

#ifndef Se_bitmapHPP
#define Se_bitmapHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <Clipbrd.hpp>	// Pascal unit
#include <Se_winapi.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Se_bitmap
{
//-- type declarations -------------------------------------------------------
typedef unsigned TseColor;

typedef TseColor *PseColor;

struct TseColorRec;
typedef TseColorRec *PseColorRec;

#pragma pack(push,1)
struct TseColorRec
{
	
	union
	{
		struct 
		{
			System::Byte B;
			System::Byte G;
			System::Byte R;
			System::Byte A;
			
		};
		struct 
		{
			System::Word HiWord;
			System::Word LoWord;
			
		};
		struct 
		{
			unsigned Color;
			
		};
		
	};
};
#pragma pack(pop)


struct TseColorRecBor;
typedef TseColorRecBor *PseColorRecBor;

#pragma pack(push,1)
struct TseColorRecBor
{
	
	union
	{
		struct 
		{
			System::Byte R;
			System::Byte G;
			System::Byte B;
			System::Byte A;
			
		};
		struct 
		{
			System::Word HiWord;
			System::Word LoWord;
			
		};
		struct 
		{
			unsigned Color;
			
		};
		
	};
};
#pragma pack(pop)


typedef StaticArray<TseColor, 1> TseColorArray;

typedef TseColorArray *PseColorArray;

typedef StaticArray<TseColorRec, 1> TseColorRecArray;

typedef TseColorRecArray *PseColorRecArray;

typedef DynamicArray<TseColor> TArrayOfseColor;

class DELPHICLASS TseBitmap;
class DELPHICLASS TseBitmapLink;
class PASCALIMPLEMENTATION TseBitmap : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	TseColorArray *FBits;
	int FWidth;
	int FHeight;
	System::UnicodeString FName;
	#pragma pack(push,1)
	tagBITMAPINFO FBitmapInfo;
	#pragma pack(pop)
	HBITMAP FHandle;
	HDC FDC;
	Graphics::TCanvas* FCanvas;
	bool FAlphaBlend;
	bool FTransparent;
	bool FNewFormat;
	TseColor __fastcall GetPixel(int X, int Y);
	void __fastcall SetPixel(int X, int Y, TseColor Value);
	PseColor __fastcall GetPixelPtr(int X, int Y);
	PseColorArray __fastcall GetScanLine(int Y);
	Graphics::TCanvas* __fastcall GetCanvas(void);
	
public:
	__fastcall virtual TseBitmap(void);
	__fastcall virtual ~TseBitmap(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall AssignTo(Classes::TPersistent* Dest);
	void __fastcall CheckRGBA(void);
	void __fastcall SetSize(int AWidth, int AHeight);
	void __fastcall Clear(TseColor Color);
	bool __fastcall Empty(void);
	void __fastcall LoadFromStream(Classes::TStream* Stream);
	void __fastcall SaveToStream(Classes::TStream* Stream);
	void __fastcall LoadFromPcxStream(Classes::TStream* Stream);
	void __fastcall LoadFromResource(const System::UnicodeString ResFileName, const System::UnicodeString ResName);
	TseBitmapLink* __fastcall GetBitmapLink(const Types::TRect &Rect)/* overload */;
	TseBitmapLink* __fastcall GetBitmapLink(System::UnicodeString Rect)/* overload */;
	void __fastcall CheckingTransparent(TseColor Color = (TseColor)(0x7f007f))/* overload */;
	void __fastcall CheckingTransparent(const Types::TRect &ARect, TseColor Color = (TseColor)(0x7f007f))/* overload */;
	void __fastcall CheckingAlphaBlend(void)/* overload */;
	void __fastcall CheckingAlphaBlend(const Types::TRect &ARect)/* overload */;
	void __fastcall SetAlpha(System::Byte Alpha)/* overload */;
	void __fastcall SetAlpha(System::Byte Alpha, const Types::TRect &Rect)/* overload */;
	void __fastcall SetBitmapHue(int Hue);
	void __fastcall ChangeBitmapSat(int DeltaSat);
	void __fastcall ChangeBitmapHue(int DeltaHue);
	void __fastcall ChangeBitmapBrightness(int DeltaBrightness);
	void __fastcall FlipVert(void);
	void __fastcall Reflection(void);
	void __fastcall Reflection2(void);
	void __fastcall Reflection3(void);
	void __fastcall MoveTo(int X, int Y);
	void __fastcall LineTo(int X, int Y, TseColor Color);
	void __fastcall DrawGraphic(Graphics::TGraphic* Graphic, const Types::TRect &DstRect);
	void __fastcall FillRect(const Types::TRect &R, TseColor Color);
	void __fastcall FillRoundRect(const Types::TRect &R, int Radius, TseColor Color);
	void __fastcall FillHalftoneRect(const Types::TRect &R, TseColor Color, TseColor HalfColor);
	void __fastcall FillGradientRect(const Types::TRect &Rect, TseColor BeginColor, TseColor EndColor, bool Vertical);
	void __fastcall FillRadialGradientRect(const Types::TRect &Rect, TseColor BeginColor, TseColor EndColor, const Types::TPoint &Pos);
	void __fastcall FillEllipse(const Types::TRect &R, TseColor Color);
	void __fastcall FillPolygon(Types::TPoint *Points, const int Points_Size, Graphics::TColor Color);
	void __fastcall FillHalftonePolygon(Types::TPoint *Points, const int Points_Size, TseColor Color, TseColor HalfColor);
	void __fastcall DrawEdge(const Types::TRect &R, TseColor RaisedColor, TseColor SunkenColor);
	void __fastcall DrawBevel(const Types::TRect &R, TseColor Color, int Width, bool Down);
	void __fastcall DrawRect(const Types::TRect &R, TseColor Color);
	void __fastcall DrawFocusRect(const Types::TRect &R, TseColor Color);
	void __fastcall DrawRoundRect(const Types::TRect &R, int Radius, TseColor Color);
	void __fastcall DrawLine(const Types::TRect &R, TseColor Color);
	void __fastcall DrawEllipse(const Types::TRect &R, TseColor Color);
	void __fastcall DrawPolygon(Types::TPoint *Points, const int Points_Size, Graphics::TColor Color);
	int __fastcall DrawText(System::WideString AText, Types::TRect &Bounds, unsigned Flag)/* overload */;
	int __fastcall DrawText(System::WideString AText, int X, int Y)/* overload */;
	int __fastcall DrawVerticalText(System::WideString AText, const Types::TRect &Bounds, unsigned Flag, bool FromTop);
	int __fastcall TextWidth(System::WideString AText, int Flags = 0x0);
	int __fastcall TextHeight(System::WideString AText);
	void __fastcall Draw(HDC DC, int X, int Y)/* overload */;
	void __fastcall Draw(HDC DC, int X, int Y, const Types::TRect &SrcRect)/* overload */;
	void __fastcall Draw(HDC DC, const Types::TRect &DstRect)/* overload */;
	void __fastcall Draw(HDC DC, const Types::TRect &DstRect, const Types::TRect &SrcRect)/* overload */;
	void __fastcall Draw(Graphics::TCanvas* Canvas, int X, int Y)/* overload */;
	void __fastcall Draw(Graphics::TCanvas* Canvas, int X, int Y, const Types::TRect &SrcRect)/* overload */;
	void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &DstRect)/* overload */;
	void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &DstRect, const Types::TRect &SrcRect)/* overload */;
	void __fastcall Draw(TseBitmap* Bitmap, int X, int Y)/* overload */;
	void __fastcall Draw(TseBitmap* Bitmap, int X, int Y, const Types::TRect &SrcRect)/* overload */;
	void __fastcall Draw(TseBitmap* Bitmap, const Types::TRect &DstRect)/* overload */;
	void __fastcall Draw(TseBitmap* Bitmap, const Types::TRect &DstRect, const Types::TRect &SrcRect)/* overload */;
	void __fastcall Tile(HDC DC, const Types::TRect &DstRect, const Types::TRect &SrcRect)/* overload */;
	void __fastcall Tile(Graphics::TCanvas* Canvas, const Types::TRect &DstRect, const Types::TRect &SrcRect)/* overload */;
	void __fastcall Tile(TseBitmap* Bitmap, const Types::TRect &DstRect, const Types::TRect &SrcRect)/* overload */;
	void __fastcall TileClip(HDC DC, const Types::TRect &DstRect, const Types::TRect &DstClip, const Types::TRect &SrcRect)/* overload */;
	void __fastcall TileClip(Graphics::TCanvas* Canvas, const Types::TRect &DstRect, const Types::TRect &DstClip, const Types::TRect &SrcRect)/* overload */;
	void __fastcall TileClip(TseBitmap* Bitmap, const Types::TRect &DstRect, const Types::TRect &DstClip, const Types::TRect &SrcRect)/* overload */;
	void __fastcall MergeDraw(TseBitmap* Bitmap, int X, int Y, const Types::TRect &SrcRect);
	__property HBITMAP Handle = {read=FHandle, nodefault};
	__property HDC DC = {read=FDC, nodefault};
	__property Graphics::TCanvas* Canvas = {read=GetCanvas};
	__property PseColorArray Bits = {read=FBits};
	__property TseColor Pixels[int X][int Y] = {read=GetPixel, write=SetPixel/*, default*/};
	__property PseColor PixelPtr[int X][int Y] = {read=GetPixelPtr};
	__property PseColorArray ScanLine[int Y] = {read=GetScanLine};
	__property int Width = {read=FWidth, nodefault};
	__property int Height = {read=FHeight, nodefault};
	__property bool AlphaBlend = {read=FAlphaBlend, write=FAlphaBlend, nodefault};
	__property bool Transparent = {read=FTransparent, write=FTransparent, nodefault};
	__property System::UnicodeString Name = {read=FName, write=FName};
	__property bool NewFormat = {read=FNewFormat, write=FNewFormat, nodefault};
};


class PASCALIMPLEMENTATION TseBitmapLink : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	TseBitmap* FImage;
	Types::TRect FRect;
	System::UnicodeString FName;
	bool FMaskedBorder;
	bool FMaskedAngles;
	bool FMasked;
	int __fastcall GetBottom(void);
	int __fastcall GetLeft(void);
	int __fastcall GetRight(void);
	int __fastcall GetTop(void);
	void __fastcall SetBottom(const int Value);
	void __fastcall SetLeft(const int Value);
	void __fastcall SetRight(const int Value);
	void __fastcall SetTop(const int Value);
	bool __fastcall GetAssigned(void);
	
public:
	__fastcall TseBitmapLink(void);
	__fastcall virtual ~TseBitmapLink(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall LoadFromStream(Classes::TStream* Stream);
	void __fastcall SaveToStream(Classes::TStream* Stream);
	void __fastcall CheckingMasked(void)/* overload */;
	void __fastcall CheckingMasked(const Types::TRect &Margin)/* overload */;
	void __fastcall Draw(Graphics::TCanvas* Canvas, int X, int Y)/* overload */;
	void __fastcall Draw(TseBitmap* Bitmap, int X, int Y)/* overload */;
	__property bool Assigned = {read=GetAssigned, nodefault};
	__property TseBitmap* Image = {read=FImage, write=FImage};
	__property Types::TRect Rect = {read=FRect, write=FRect};
	__property bool Masked = {read=FMasked, write=FMasked, nodefault};
	__property bool MaskedBorder = {read=FMaskedBorder, write=FMaskedBorder, nodefault};
	__property bool MaskedAngles = {read=FMaskedAngles, write=FMaskedAngles, nodefault};
	
__published:
	__property System::UnicodeString Name = {read=FName, write=FName};
	__property int Left = {read=GetLeft, write=SetLeft, nodefault};
	__property int Top = {read=GetTop, write=SetTop, nodefault};
	__property int Right = {read=GetRight, write=SetRight, nodefault};
	__property int Bottom = {read=GetBottom, write=SetBottom, nodefault};
};


class DELPHICLASS TseBitmapList;
class PASCALIMPLEMENTATION TseBitmapList : public Classes::TList
{
	typedef Classes::TList inherited;
	
public:
	TseBitmap* operator[](int index) { return Bitmaps[index]; }
	
private:
	TseBitmap* __fastcall GetImage(int index);
	TseBitmap* __fastcall GetBitmapByName(System::UnicodeString index);
	
public:
	__fastcall virtual TseBitmapList(void);
	__fastcall virtual ~TseBitmapList(void);
	virtual void __fastcall Clear(void);
	TseBitmapLink* __fastcall GetBitmapLink(TseBitmap* Image, const Types::TRect &Rect)/* overload */;
	TseBitmapLink* __fastcall GetBitmapLink(System::UnicodeString Name, const Types::TRect &Rect)/* overload */;
	TseBitmapLink* __fastcall GetBitmapLink(System::UnicodeString Name, System::UnicodeString Rect)/* overload */;
	__property TseBitmap* Bitmaps[int index] = {read=GetImage/*, default*/};
	__property TseBitmap* BitmapByName[System::UnicodeString index] = {read=GetBitmapByName};
};


typedef TseColor __fastcall (*TseAlphaBlendPixel)(TseColor Src, TseColor Dst);

typedef void __fastcall (*TseAlphaBlendLine)(PseColor Src, PseColor Dst, int Count);

typedef void __fastcall (*TseTransparentLine)(PseColor Src, PseColor Dst, int Count);

typedef void __fastcall (*TseMoveLongword)(const void * Src, void * Dst, int Count);

typedef void __fastcall (*TseFillLongword)(void * Src, int Count, unsigned Value);

typedef void __fastcall (*TseFillLongwordRect)(void * Src, int W, int H, int X1, int Y1, int X2, int Y2, unsigned Value);

typedef void __fastcall (*TseFillAlpha)(void * Src, int Count, System::Byte Alpha);

typedef void __fastcall (*TseFillAlphaRect)(void * Src, int W, int H, int X1, int Y1, int X2, int Y2, System::Byte Alpha);

typedef void __fastcall (*TseClearAlpha)(void * Src, int Count, unsigned Value);

typedef void __fastcall (*TseStretchToDCOpaque)(HDC DstDC, int DstX, int DstY, int DstW, int DstH, TseBitmap* SrcBmp, int SrcX, int SrcY, int SrcW, int SrcH);

typedef void __fastcall (*TseStretchToDCTransparent)(HDC DstDC, int DstX, int DstY, int DstW, int DstH, TseBitmap* SrcBmp, int SrcX, int SrcY, int SrcW, int SrcH);

typedef void __fastcall (*TseStretchToDCAlphaBlend)(HDC DstDC, int DstX, int DstY, int DstW, int DstH, TseBitmap* SrcBmp, int SrcX, int SrcY, int SrcW, int SrcH);

typedef void __fastcall (*TseStretchToDibOpaque)(void * Bits, const Types::TRect &DstRect, const Types::TRect &DstClip, int BitsW, int BitsH, TseBitmap* Src, const Types::TRect &SrcRect);

typedef void __fastcall (*TseStretchToDibTransparent)(void * Bits, const Types::TRect &DstRect, const Types::TRect &DstClip, int BitsW, int BitsH, TseBitmap* Src, const Types::TRect &SrcRect);

typedef void __fastcall (*TseStretchToDibAlphaBlend)(void * Bits, const Types::TRect &DstRect, const Types::TRect &DstClip, int BitsW, int BitsH, TseBitmap* Src, const Types::TRect &SrcRect);

typedef void __fastcall (*TseStretchOpaque)(TseBitmap* Dst, const Types::TRect &DstRect, const Types::TRect &DstClip, TseBitmap* Src, const Types::TRect &SrcRect);

typedef void __fastcall (*TseStretchTransparent)(TseBitmap* Dst, const Types::TRect &DstRect, const Types::TRect &DstClip, TseBitmap* Src, const Types::TRect &SrcRect);

typedef void __fastcall (*TseStretchAlphaBlend)(TseBitmap* Dst, const Types::TRect &DstRect, const Types::TRect &DstClip, TseBitmap* Src, const Types::TRect &SrcRect);

typedef void __fastcall (*TseBltOpaque)(TseBitmap* Dst, const Types::TRect &DstRect, TseBitmap* Src, int SrcX, int SrcY);

typedef void __fastcall (*TseBltTransparent)(TseBitmap* Dst, const Types::TRect &DstRect, TseBitmap* Src, int SrcX, int SrcY);

typedef void __fastcall (*TseBltAlphaBlend)(TseBitmap* Dst, const Types::TRect &DstRect, TseBitmap* Src, int SrcX, int SrcY);

typedef void * __fastcall (*TseGetBitsFromDC)(HDC DC, int &Width, int &Height, int &BitCount);

//-- var, const, procedure ---------------------------------------------------
static const int seTransparent = 0x7f007f;
static const unsigned AlphaMask = 0xff000000;
extern PACKAGE TseColor seBlack;
extern PACKAGE TseColor seGray;
extern PACKAGE TseColor seWhite;
extern PACKAGE TseColor seMaroon;
extern PACKAGE TseColor seGreen;
extern PACKAGE TseColor seOlive;
extern PACKAGE TseColor seNavy;
extern PACKAGE TseColor sePurple;
extern PACKAGE TseColor seTeal;
extern PACKAGE TseColor seRed;
extern PACKAGE TseColor seLime;
extern PACKAGE TseColor seYellow;
extern PACKAGE TseColor seBlue;
extern PACKAGE TseColor seFuchsia;
extern PACKAGE TseColor seAqua;
extern PACKAGE TseColor seMenu;
extern PACKAGE TseColor seBorder;
extern PACKAGE TseColor seWindow;
extern PACKAGE TseColor seBtnFace;
extern PACKAGE TseColor seBtnShadow;
extern PACKAGE TseColor seHotHighlight;
extern PACKAGE TseColor seHighlight;
extern PACKAGE TseColor seHintBack;
extern PACKAGE TseColor seNone;
extern PACKAGE TseColor seTransparentVar;
extern PACKAGE bool EnableDibOperation;
extern PACKAGE TseAlphaBlendPixel PixelAlphaBlendFunc;
extern PACKAGE TseAlphaBlendLine LineAlphaBlendFunc;
extern PACKAGE TseTransparentLine LineTransparentFunc;
extern PACKAGE TseMoveLongword MoveLongwordFunc;
extern PACKAGE TseFillLongword FillLongwordFunc;
extern PACKAGE TseFillLongwordRect FillLongwordRectFunc;
extern PACKAGE TseFillAlpha FillAlphaFunc;
extern PACKAGE TseFillAlphaRect FillAlphaRectFunc;
extern PACKAGE TseClearAlpha ClearAlphaFunc;
extern PACKAGE TseStretchToDCOpaque StretchToDCOpaqueFunc;
extern PACKAGE TseStretchToDCAlphaBlend StretchToDCAlphaBlendFunc;
extern PACKAGE TseStretchToDCTransparent StretchToDCTransparentFunc;
extern PACKAGE TseGetBitsFromDC GetBitsFromDCFunc;
extern PACKAGE TseStretchToDibOpaque StretchToDibOpaqueFunc;
extern PACKAGE TseStretchToDibAlphaBlend StretchToDibAlphaBlendFunc;
extern PACKAGE TseStretchToDibTransparent StretchToDibTransparentFunc;
extern PACKAGE TseBltOpaque BltOpaqueFunc;
extern PACKAGE TseBltAlphaBlend BltAlphaBlendFunc;
extern PACKAGE TseBltTransparent BltTransparentFunc;
extern PACKAGE TseStretchOpaque StretchOpaqueFunc;
extern PACKAGE TseStretchAlphaBlend StretchAlphaBlendFunc;
extern PACKAGE TseStretchTransparent StretchTransparentFunc;
extern PACKAGE TseColor __fastcall seColor(Graphics::TColor Color, System::Byte A = (System::Byte)(0xff))/* overload */;
extern PACKAGE TseColor __fastcall seColor(short R, short G, short B, System::Byte A = (System::Byte)(0xff))/* overload */;
extern PACKAGE TseColor __fastcall seColor(TseColorRec ColorRec)/* overload */;
extern PACKAGE Graphics::TColor __fastcall seColorToColor(TseColor Color);
extern PACKAGE System::Word __fastcall seColorToColor16(TseColor Color);
extern PACKAGE System::Word __fastcall seColorToColor15(TseColor Color);
extern PACKAGE TseColor __fastcall HSLtoRGB(float H, float S, float L);
extern PACKAGE void __fastcall RGBtoHSL(TseColor RGB, /* out */ float &H, /* out */ float &S, /* out */ float &L);
extern PACKAGE TseColor __fastcall SetHue(TseColor Color, int Hue);
extern PACKAGE TseColor __fastcall ChangeSat(TseColor Color, int DeltaSat);
extern PACKAGE TseColor __fastcall ChangeHue(TseColor Color, int DeltaHue);
extern PACKAGE TseColor __fastcall ChangeBrightness(TseColor Color, int DeltaBrightness);
extern PACKAGE TseColor __fastcall ChangeColor(TseColor Color, short Dr, short Dg, short Db, short Da = (short)(0x0))/* overload */;
extern PACKAGE TseColor __fastcall ChangeColor(TseColor Color, short Dx)/* overload */;
extern PACKAGE Graphics::TColor __fastcall StdChangeColor(Graphics::TColor Color, short Dr, short Dg, short Db, short Da = (short)(0x0))/* overload */;
extern PACKAGE Graphics::TColor __fastcall StdChangeColor(Graphics::TColor Color, short Dx)/* overload */;
extern PACKAGE TseColor __fastcall SunkenColor(TseColor Color, short Dr, short Dg, short Db, short Da = (short)(0x0))/* overload */;
extern PACKAGE TseColor __fastcall SunkenColor(TseColor Color, short Dx)/* overload */;
extern PACKAGE TseColor __fastcall RaisedColor(TseColor Color, short Dr, short Dg, short Db, short Da = (short)(0x0))/* overload */;
extern PACKAGE TseColor __fastcall RaisedColor(TseColor Color, short Dx)/* overload */;
extern PACKAGE unsigned __fastcall FromRGB(unsigned Color);
extern PACKAGE unsigned __fastcall ToRGB(unsigned Color32);
extern PACKAGE System::Word __fastcall MulDiv16(System::Word Number, System::Word Numerator, System::Word Denominator);
extern PACKAGE void __fastcall Blur(const TseBitmap* Bitmap, const int Radius);

}	/* namespace Se_bitmap */
using namespace Se_bitmap;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Se_bitmapHPP
